Merge branch 'ps/pathspec-empty-prefix-origin'
[git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29         FAKE_EDITOR="$1"
30         export FAKE_EDITOR
31         EDITOR='"$FAKE_EDITOR"'
32         export EDITOR
33 }
34
35 test_set_index_version () {
36     GIT_INDEX_VERSION="$1"
37     export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41         awk '
42                 function name(n) {
43                         if (n == 0) return "RESET";
44                         if (n == 1) return "BOLD";
45                         if (n == 30) return "BLACK";
46                         if (n == 31) return "RED";
47                         if (n == 32) return "GREEN";
48                         if (n == 33) return "YELLOW";
49                         if (n == 34) return "BLUE";
50                         if (n == 35) return "MAGENTA";
51                         if (n == 36) return "CYAN";
52                         if (n == 37) return "WHITE";
53                         if (n == 40) return "BLACK";
54                         if (n == 41) return "BRED";
55                         if (n == 42) return "BGREEN";
56                         if (n == 43) return "BYELLOW";
57                         if (n == 44) return "BBLUE";
58                         if (n == 45) return "BMAGENTA";
59                         if (n == 46) return "BCYAN";
60                         if (n == 47) return "BWHITE";
61                 }
62                 {
63                         while (match($0, /\033\[[0-9;]*m/) != 0) {
64                                 printf "%s<", substr($0, 1, RSTART-1);
65                                 codes = substr($0, RSTART+2, RLENGTH-3);
66                                 if (length(codes) == 0)
67                                         printf "%s", name(0)
68                                 else {
69                                         n = split(codes, ary, ";");
70                                         sep = "";
71                                         for (i = 1; i <= n; i++) {
72                                                 printf "%s%s", sep, name(ary[i]);
73                                                 sep = ";"
74                                         }
75                                 }
76                                 printf ">";
77                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
78                         }
79                         print
80                 }
81         '
82 }
83
84 lf_to_nul () {
85         perl -pe 'y/\012/\000/'
86 }
87
88 nul_to_q () {
89         perl -pe 'y/\000/Q/'
90 }
91
92 q_to_nul () {
93         perl -pe 'y/Q/\000/'
94 }
95
96 q_to_cr () {
97         tr Q '\015'
98 }
99
100 q_to_tab () {
101         tr Q '\011'
102 }
103
104 qz_to_tab_space () {
105         tr QZ '\011\040'
106 }
107
108 append_cr () {
109         sed -e 's/$/Q/' | tr Q '\015'
110 }
111
112 remove_cr () {
113         tr '\015' Q | sed -e 's/Q$//'
114 }
115
116 # In some bourne shell implementations, the "unset" builtin returns
117 # nonzero status when a variable to be unset was not set in the first
118 # place.
119 #
120 # Use sane_unset when that should not be considered an error.
121
122 sane_unset () {
123         unset "$@"
124         return 0
125 }
126
127 test_tick () {
128         if test -z "${test_tick+set}"
129         then
130                 test_tick=1112911993
131         else
132                 test_tick=$(($test_tick + 60))
133         fi
134         GIT_COMMITTER_DATE="$test_tick -0700"
135         GIT_AUTHOR_DATE="$test_tick -0700"
136         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
137 }
138
139 # Stop execution and start a shell. This is useful for debugging tests.
140 #
141 # Be sure to remove all invocations of this command before submitting.
142
143 test_pause () {
144         "$SHELL_PATH" <&6 >&5 2>&7
145 }
146
147 # Wrap git in gdb. Adding this to a command can make it easier to
148 # understand what is going on in a failing test.
149 #
150 # Example: "debug git checkout master".
151 debug () {
152          GIT_TEST_GDB=1 "$@" <&6 >&5 2>&7
153 }
154
155 # Call test_commit with the arguments
156 # [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
157 #
158 # This will commit a file with the given contents and the given commit
159 # message, and tag the resulting commit with the given tag name.
160 #
161 # <file>, <contents>, and <tag> all default to <message>.
162 #
163 # If the first argument is "-C", the second argument is used as a path for
164 # the git invocations.
165
166 test_commit () {
167         notick= &&
168         signoff= &&
169         indir= &&
170         while test $# != 0
171         do
172                 case "$1" in
173                 --notick)
174                         notick=yes
175                         ;;
176                 --signoff)
177                         signoff="$1"
178                         ;;
179                 -C)
180                         indir="$2"
181                         shift
182                         ;;
183                 *)
184                         break
185                         ;;
186                 esac
187                 shift
188         done &&
189         indir=${indir:+"$indir"/} &&
190         file=${2:-"$1.t"} &&
191         echo "${3-$1}" > "$indir$file" &&
192         git ${indir:+ -C "$indir"} add "$file" &&
193         if test -z "$notick"
194         then
195                 test_tick
196         fi &&
197         git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
198         git ${indir:+ -C "$indir"} tag "${4:-$1}"
199 }
200
201 # Call test_merge with the arguments "<message> <commit>", where <commit>
202 # can be a tag pointing to the commit-to-merge.
203
204 test_merge () {
205         test_tick &&
206         git merge -m "$1" "$2" &&
207         git tag "$1"
208 }
209
210 # This function helps systems where core.filemode=false is set.
211 # Use it instead of plain 'chmod +x' to set or unset the executable bit
212 # of a file in the working directory and add it to the index.
213
214 test_chmod () {
215         chmod "$@" &&
216         git update-index --add "--chmod=$@"
217 }
218
219 # Unset a configuration variable, but don't fail if it doesn't exist.
220 test_unconfig () {
221         config_dir=
222         if test "$1" = -C
223         then
224                 shift
225                 config_dir=$1
226                 shift
227         fi
228         git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
229         config_status=$?
230         case "$config_status" in
231         5) # ok, nothing to unset
232                 config_status=0
233                 ;;
234         esac
235         return $config_status
236 }
237
238 # Set git config, automatically unsetting it after the test is over.
239 test_config () {
240         config_dir=
241         if test "$1" = -C
242         then
243                 shift
244                 config_dir=$1
245                 shift
246         fi
247         test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
248         git ${config_dir:+-C "$config_dir"} config "$@"
249 }
250
251 test_config_global () {
252         test_when_finished "test_unconfig --global '$1'" &&
253         git config --global "$@"
254 }
255
256 write_script () {
257         {
258                 echo "#!${2-"$SHELL_PATH"}" &&
259                 cat
260         } >"$1" &&
261         chmod +x "$1"
262 }
263
264 # Use test_set_prereq to tell that a particular prerequisite is available.
265 # The prerequisite can later be checked for in two ways:
266 #
267 # - Explicitly using test_have_prereq.
268 #
269 # - Implicitly by specifying the prerequisite tag in the calls to
270 #   test_expect_{success,failure,code}.
271 #
272 # The single parameter is the prerequisite tag (a simple word, in all
273 # capital letters by convention).
274
275 test_set_prereq () {
276         satisfied_prereq="$satisfied_prereq$1 "
277 }
278 satisfied_prereq=" "
279 lazily_testable_prereq= lazily_tested_prereq=
280
281 # Usage: test_lazy_prereq PREREQ 'script'
282 test_lazy_prereq () {
283         lazily_testable_prereq="$lazily_testable_prereq$1 "
284         eval test_prereq_lazily_$1=\$2
285 }
286
287 test_run_lazy_prereq_ () {
288         script='
289 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
290 (
291         cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
292 )'
293         say >&3 "checking prerequisite: $1"
294         say >&3 "$script"
295         test_eval_ "$script"
296         eval_ret=$?
297         rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
298         if test "$eval_ret" = 0; then
299                 say >&3 "prerequisite $1 ok"
300         else
301                 say >&3 "prerequisite $1 not satisfied"
302         fi
303         return $eval_ret
304 }
305
306 test_have_prereq () {
307         # prerequisites can be concatenated with ','
308         save_IFS=$IFS
309         IFS=,
310         set -- $*
311         IFS=$save_IFS
312
313         total_prereq=0
314         ok_prereq=0
315         missing_prereq=
316
317         for prerequisite
318         do
319                 case "$prerequisite" in
320                 !*)
321                         negative_prereq=t
322                         prerequisite=${prerequisite#!}
323                         ;;
324                 *)
325                         negative_prereq=
326                 esac
327
328                 case " $lazily_tested_prereq " in
329                 *" $prerequisite "*)
330                         ;;
331                 *)
332                         case " $lazily_testable_prereq " in
333                         *" $prerequisite "*)
334                                 eval "script=\$test_prereq_lazily_$prerequisite" &&
335                                 if test_run_lazy_prereq_ "$prerequisite" "$script"
336                                 then
337                                         test_set_prereq $prerequisite
338                                 fi
339                                 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
340                         esac
341                         ;;
342                 esac
343
344                 total_prereq=$(($total_prereq + 1))
345                 case "$satisfied_prereq" in
346                 *" $prerequisite "*)
347                         satisfied_this_prereq=t
348                         ;;
349                 *)
350                         satisfied_this_prereq=
351                 esac
352
353                 case "$satisfied_this_prereq,$negative_prereq" in
354                 t,|,t)
355                         ok_prereq=$(($ok_prereq + 1))
356                         ;;
357                 *)
358                         # Keep a list of missing prerequisites; restore
359                         # the negative marker if necessary.
360                         prerequisite=${negative_prereq:+!}$prerequisite
361                         if test -z "$missing_prereq"
362                         then
363                                 missing_prereq=$prerequisite
364                         else
365                                 missing_prereq="$prerequisite,$missing_prereq"
366                         fi
367                 esac
368         done
369
370         test $total_prereq = $ok_prereq
371 }
372
373 test_declared_prereq () {
374         case ",$test_prereq," in
375         *,$1,*)
376                 return 0
377                 ;;
378         esac
379         return 1
380 }
381
382 test_verify_prereq () {
383         test -z "$test_prereq" ||
384         expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
385         error "bug in the test script: '$test_prereq' does not look like a prereq"
386 }
387
388 test_expect_failure () {
389         test_start_
390         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
391         test "$#" = 2 ||
392         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
393         test_verify_prereq
394         export test_prereq
395         if ! test_skip "$@"
396         then
397                 say >&3 "checking known breakage: $2"
398                 if test_run_ "$2" expecting_failure
399                 then
400                         test_known_broken_ok_ "$1"
401                 else
402                         test_known_broken_failure_ "$1"
403                 fi
404         fi
405         test_finish_
406 }
407
408 test_expect_success () {
409         test_start_
410         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
411         test "$#" = 2 ||
412         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
413         test_verify_prereq
414         export test_prereq
415         if ! test_skip "$@"
416         then
417                 say >&3 "expecting success: $2"
418                 if test_run_ "$2"
419                 then
420                         test_ok_ "$1"
421                 else
422                         test_failure_ "$@"
423                 fi
424         fi
425         test_finish_
426 }
427
428 # test_external runs external test scripts that provide continuous
429 # test output about their progress, and succeeds/fails on
430 # zero/non-zero exit code.  It outputs the test output on stdout even
431 # in non-verbose mode, and announces the external script with "# run
432 # <n>: ..." before running it.  When providing relative paths, keep in
433 # mind that all scripts run in "trash directory".
434 # Usage: test_external description command arguments...
435 # Example: test_external 'Perl API' perl ../path/to/test.pl
436 test_external () {
437         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
438         test "$#" = 3 ||
439         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
440         descr="$1"
441         shift
442         test_verify_prereq
443         export test_prereq
444         if ! test_skip "$descr" "$@"
445         then
446                 # Announce the script to reduce confusion about the
447                 # test output that follows.
448                 say_color "" "# run $test_count: $descr ($*)"
449                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
450                 # to be able to use them in script
451                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
452                 # Run command; redirect its stderr to &4 as in
453                 # test_run_, but keep its stdout on our stdout even in
454                 # non-verbose mode.
455                 "$@" 2>&4
456                 if test "$?" = 0
457                 then
458                         if test $test_external_has_tap -eq 0; then
459                                 test_ok_ "$descr"
460                         else
461                                 say_color "" "# test_external test $descr was ok"
462                                 test_success=$(($test_success + 1))
463                         fi
464                 else
465                         if test $test_external_has_tap -eq 0; then
466                                 test_failure_ "$descr" "$@"
467                         else
468                                 say_color error "# test_external test $descr failed: $@"
469                                 test_failure=$(($test_failure + 1))
470                         fi
471                 fi
472         fi
473 }
474
475 # Like test_external, but in addition tests that the command generated
476 # no output on stderr.
477 test_external_without_stderr () {
478         # The temporary file has no (and must have no) security
479         # implications.
480         tmp=${TMPDIR:-/tmp}
481         stderr="$tmp/git-external-stderr.$$.tmp"
482         test_external "$@" 4> "$stderr"
483         test -f "$stderr" || error "Internal error: $stderr disappeared."
484         descr="no stderr: $1"
485         shift
486         say >&3 "# expecting no stderr from previous command"
487         if test ! -s "$stderr"
488         then
489                 rm "$stderr"
490
491                 if test $test_external_has_tap -eq 0; then
492                         test_ok_ "$descr"
493                 else
494                         say_color "" "# test_external_without_stderr test $descr was ok"
495                         test_success=$(($test_success + 1))
496                 fi
497         else
498                 if test "$verbose" = t
499                 then
500                         output=$(echo; echo "# Stderr is:"; cat "$stderr")
501                 else
502                         output=
503                 fi
504                 # rm first in case test_failure exits.
505                 rm "$stderr"
506                 if test $test_external_has_tap -eq 0; then
507                         test_failure_ "$descr" "$@" "$output"
508                 else
509                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
510                         test_failure=$(($test_failure + 1))
511                 fi
512         fi
513 }
514
515 # debugging-friendly alternatives to "test [-f|-d|-e]"
516 # The commands test the existence or non-existence of $1. $2 can be
517 # given to provide a more precise diagnosis.
518 test_path_is_file () {
519         if ! test -f "$1"
520         then
521                 echo "File $1 doesn't exist. $2"
522                 false
523         fi
524 }
525
526 test_path_is_dir () {
527         if ! test -d "$1"
528         then
529                 echo "Directory $1 doesn't exist. $2"
530                 false
531         fi
532 }
533
534 # Check if the directory exists and is empty as expected, barf otherwise.
535 test_dir_is_empty () {
536         test_path_is_dir "$1" &&
537         if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
538         then
539                 echo "Directory '$1' is not empty, it contains:"
540                 ls -la "$1"
541                 return 1
542         fi
543 }
544
545 test_path_is_missing () {
546         if test -e "$1"
547         then
548                 echo "Path exists:"
549                 ls -ld "$1"
550                 if test $# -ge 1
551                 then
552                         echo "$*"
553                 fi
554                 false
555         fi
556 }
557
558 # test_line_count checks that a file has the number of lines it
559 # ought to. For example:
560 #
561 #       test_expect_success 'produce exactly one line of output' '
562 #               do something >output &&
563 #               test_line_count = 1 output
564 #       '
565 #
566 # is like "test $(wc -l <output) = 1" except that it passes the
567 # output through when the number of lines is wrong.
568
569 test_line_count () {
570         if test $# != 3
571         then
572                 error "bug in the test script: not 3 parameters to test_line_count"
573         elif ! test $(wc -l <"$3") "$1" "$2"
574         then
575                 echo "test_line_count: line count for $3 !$1 $2"
576                 cat "$3"
577                 return 1
578         fi
579 }
580
581 # Returns success if a comma separated string of keywords ($1) contains a
582 # given keyword ($2).
583 # Examples:
584 # `list_contains "foo,bar" bar` returns 0
585 # `list_contains "foo" bar` returns 1
586
587 list_contains () {
588         case ",$1," in
589         *,$2,*)
590                 return 0
591                 ;;
592         esac
593         return 1
594 }
595
596 # This is not among top-level (test_expect_success | test_expect_failure)
597 # but is a prefix that can be used in the test script, like:
598 #
599 #       test_expect_success 'complain and die' '
600 #           do something &&
601 #           do something else &&
602 #           test_must_fail git checkout ../outerspace
603 #       '
604 #
605 # Writing this as "! git checkout ../outerspace" is wrong, because
606 # the failure could be due to a segv.  We want a controlled failure.
607
608 test_must_fail () {
609         case "$1" in
610         ok=*)
611                 _test_ok=${1#ok=}
612                 shift
613                 ;;
614         *)
615                 _test_ok=
616                 ;;
617         esac
618         "$@"
619         exit_code=$?
620         if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
621         then
622                 echo >&2 "test_must_fail: command succeeded: $*"
623                 return 1
624         elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
625         then
626                 return 0
627         elif test $exit_code -gt 129 && test $exit_code -le 192
628         then
629                 echo >&2 "test_must_fail: died by signal $(($exit_code - 128)): $*"
630                 return 1
631         elif test $exit_code -eq 127
632         then
633                 echo >&2 "test_must_fail: command not found: $*"
634                 return 1
635         elif test $exit_code -eq 126
636         then
637                 echo >&2 "test_must_fail: valgrind error: $*"
638                 return 1
639         fi
640         return 0
641 }
642
643 # Similar to test_must_fail, but tolerates success, too.  This is
644 # meant to be used in contexts like:
645 #
646 #       test_expect_success 'some command works without configuration' '
647 #               test_might_fail git config --unset all.configuration &&
648 #               do something
649 #       '
650 #
651 # Writing "git config --unset all.configuration || :" would be wrong,
652 # because we want to notice if it fails due to segv.
653
654 test_might_fail () {
655         test_must_fail ok=success "$@"
656 }
657
658 # Similar to test_must_fail and test_might_fail, but check that a
659 # given command exited with a given exit code. Meant to be used as:
660 #
661 #       test_expect_success 'Merge with d/f conflicts' '
662 #               test_expect_code 1 git merge "merge msg" B master
663 #       '
664
665 test_expect_code () {
666         want_code=$1
667         shift
668         "$@"
669         exit_code=$?
670         if test $exit_code = $want_code
671         then
672                 return 0
673         fi
674
675         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
676         return 1
677 }
678
679 # test_cmp is a helper function to compare actual and expected output.
680 # You can use it like:
681 #
682 #       test_expect_success 'foo works' '
683 #               echo expected >expected &&
684 #               foo >actual &&
685 #               test_cmp expected actual
686 #       '
687 #
688 # This could be written as either "cmp" or "diff -u", but:
689 # - cmp's output is not nearly as easy to read as diff -u
690 # - not all diff versions understand "-u"
691
692 test_cmp() {
693         $GIT_TEST_CMP "$@"
694 }
695
696 # test_cmp_bin - helper to compare binary files
697
698 test_cmp_bin() {
699         cmp "$@"
700 }
701
702 # Call any command "$@" but be more verbose about its
703 # failure. This is handy for commands like "test" which do
704 # not output anything when they fail.
705 verbose () {
706         "$@" && return 0
707         echo >&2 "command failed: $(git rev-parse --sq-quote "$@")"
708         return 1
709 }
710
711 # Check if the file expected to be empty is indeed empty, and barfs
712 # otherwise.
713
714 test_must_be_empty () {
715         if test -s "$1"
716         then
717                 echo "'$1' is not empty, it contains:"
718                 cat "$1"
719                 return 1
720         fi
721 }
722
723 # Tests that its two parameters refer to the same revision
724 test_cmp_rev () {
725         git rev-parse --verify "$1" >expect.rev &&
726         git rev-parse --verify "$2" >actual.rev &&
727         test_cmp expect.rev actual.rev
728 }
729
730 # Print a sequence of integers in increasing order, either with
731 # two arguments (start and end):
732 #
733 #     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
734 #
735 # or with one argument (end), in which case it starts counting
736 # from 1.
737
738 test_seq () {
739         case $# in
740         1)      set 1 "$@" ;;
741         2)      ;;
742         *)      error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
743         esac
744         test_seq_counter__=$1
745         while test "$test_seq_counter__" -le "$2"
746         do
747                 echo "$test_seq_counter__"
748                 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
749         done
750 }
751
752 # This function can be used to schedule some commands to be run
753 # unconditionally at the end of the test to restore sanity:
754 #
755 #       test_expect_success 'test core.capslock' '
756 #               git config core.capslock true &&
757 #               test_when_finished "git config --unset core.capslock" &&
758 #               hello world
759 #       '
760 #
761 # That would be roughly equivalent to
762 #
763 #       test_expect_success 'test core.capslock' '
764 #               git config core.capslock true &&
765 #               hello world
766 #               git config --unset core.capslock
767 #       '
768 #
769 # except that the greeting and config --unset must both succeed for
770 # the test to pass.
771 #
772 # Note that under --immediate mode, no clean-up is done to help diagnose
773 # what went wrong.
774
775 test_when_finished () {
776         # We cannot detect when we are in a subshell in general, but by
777         # doing so on Bash is better than nothing (the test will
778         # silently pass on other shells).
779         test "${BASH_SUBSHELL-0}" = 0 ||
780         error "bug in test script: test_when_finished does nothing in a subshell"
781         test_cleanup="{ $*
782                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
783 }
784
785 # Most tests can use the created repository, but some may need to create more.
786 # Usage: test_create_repo <directory>
787 test_create_repo () {
788         test "$#" = 1 ||
789         error "bug in the test script: not 1 parameter to test-create-repo"
790         repo="$1"
791         mkdir -p "$repo"
792         (
793                 cd "$repo" || error "Cannot setup test environment"
794                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
795                 error "cannot run git init -- have you built things yet?"
796                 mv .git/hooks .git/hooks-disabled
797         ) || exit
798 }
799
800 # This function helps on symlink challenged file systems when it is not
801 # important that the file system entry is a symbolic link.
802 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
803 # symbolic link entry y to the index.
804
805 test_ln_s_add () {
806         if test_have_prereq SYMLINKS
807         then
808                 ln -s "$1" "$2" &&
809                 git update-index --add "$2"
810         else
811                 printf '%s' "$1" >"$2" &&
812                 ln_s_obj=$(git hash-object -w "$2") &&
813                 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
814                 # pick up stat info from the file
815                 git update-index "$2"
816         fi
817 }
818
819 # This function writes out its parameters, one per line
820 test_write_lines () {
821         printf "%s\n" "$@"
822 }
823
824 perl () {
825         command "$PERL_PATH" "$@"
826 }
827
828 # Is the value one of the various ways to spell a boolean true/false?
829 test_normalize_bool () {
830         git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
831 }
832
833 # Given a variable $1, normalize the value of it to one of "true",
834 # "false", or "auto" and store the result to it.
835 #
836 #     test_tristate GIT_TEST_HTTPD
837 #
838 # A variable set to an empty string is set to 'false'.
839 # A variable set to 'false' or 'auto' keeps its value.
840 # Anything else is set to 'true'.
841 # An unset variable defaults to 'auto'.
842 #
843 # The last rule is to allow people to set the variable to an empty
844 # string and export it to decline testing the particular feature
845 # for versions both before and after this change.  We used to treat
846 # both unset and empty variable as a signal for "do not test" and
847 # took any non-empty string as "please test".
848
849 test_tristate () {
850         if eval "test x\"\${$1+isset}\" = xisset"
851         then
852                 # explicitly set
853                 eval "
854                         case \"\$$1\" in
855                         '')     $1=false ;;
856                         auto)   ;;
857                         *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
858                         esac
859                 "
860         else
861                 eval "$1=auto"
862         fi
863 }
864
865 # Exit the test suite, either by skipping all remaining tests or by
866 # exiting with an error. If "$1" is "auto", we then we assume we were
867 # opportunistically trying to set up some tests and we skip. If it is
868 # "true", then we report a failure.
869 #
870 # The error/skip message should be given by $2.
871 #
872 test_skip_or_die () {
873         case "$1" in
874         auto)
875                 skip_all=$2
876                 test_done
877                 ;;
878         true)
879                 error "$2"
880                 ;;
881         *)
882                 error "BUG: test tristate is '$1' (real error: $2)"
883         esac
884 }
885
886 # The following mingw_* functions obey POSIX shell syntax, but are actually
887 # bash scripts, and are meant to be used only with bash on Windows.
888
889 # A test_cmp function that treats LF and CRLF equal and avoids to fork
890 # diff when possible.
891 mingw_test_cmp () {
892         # Read text into shell variables and compare them. If the results
893         # are different, use regular diff to report the difference.
894         local test_cmp_a= test_cmp_b=
895
896         # When text came from stdin (one argument is '-') we must feed it
897         # to diff.
898         local stdin_for_diff=
899
900         # Since it is difficult to detect the difference between an
901         # empty input file and a failure to read the files, we go straight
902         # to diff if one of the inputs is empty.
903         if test -s "$1" && test -s "$2"
904         then
905                 # regular case: both files non-empty
906                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
907                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
908         elif test -s "$1" && test "$2" = -
909         then
910                 # read 2nd file from stdin
911                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
912                 mingw_read_file_strip_cr_ test_cmp_b
913                 stdin_for_diff='<<<"$test_cmp_b"'
914         elif test "$1" = - && test -s "$2"
915         then
916                 # read 1st file from stdin
917                 mingw_read_file_strip_cr_ test_cmp_a
918                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
919                 stdin_for_diff='<<<"$test_cmp_a"'
920         fi
921         test -n "$test_cmp_a" &&
922         test -n "$test_cmp_b" &&
923         test "$test_cmp_a" = "$test_cmp_b" ||
924         eval "diff -u \"\$@\" $stdin_for_diff"
925 }
926
927 # $1 is the name of the shell variable to fill in
928 mingw_read_file_strip_cr_ () {
929         # Read line-wise using LF as the line separator
930         # and use IFS to strip CR.
931         local line
932         while :
933         do
934                 if IFS=$'\r' read -r -d $'\n' line
935                 then
936                         # good
937                         line=$line$'\n'
938                 else
939                         # we get here at EOF, but also if the last line
940                         # was not terminated by LF; in the latter case,
941                         # some text was read
942                         if test -z "$line"
943                         then
944                                 # EOF, really
945                                 break
946                         fi
947                 fi
948                 eval "$1=\$$1\$line"
949         done
950 }
951
952 # Like "env FOO=BAR some-program", but run inside a subshell, which means
953 # it also works for shell functions (though those functions cannot impact
954 # the environment outside of the test_env invocation).
955 test_env () {
956         (
957                 while test $# -gt 0
958                 do
959                         case "$1" in
960                         *=*)
961                                 eval "${1%%=*}=\${1#*=}"
962                                 eval "export ${1%%=*}"
963                                 shift
964                                 ;;
965                         *)
966                                 "$@"
967                                 exit
968                                 ;;
969                         esac
970                 done
971         )
972 }
973
974 # Returns true if the numeric exit code in "$2" represents the expected signal
975 # in "$1". Signals should be given numerically.
976 test_match_signal () {
977         if test "$2" = "$((128 + $1))"
978         then
979                 # POSIX
980                 return 0
981         elif test "$2" = "$((256 + $1))"
982         then
983                 # ksh
984                 return 0
985         fi
986         return 1
987 }
988
989 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
990 test_copy_bytes () {
991         perl -e '
992                 my $len = $ARGV[1];
993                 while ($len > 0) {
994                         my $s;
995                         my $nread = sysread(STDIN, $s, $len);
996                         die "cannot read: $!" unless defined($nread);
997                         print $s;
998                         $len -= $nread;
999                 }
1000         ' - "$1"
1001 }
1002
1003 # run "$@" inside a non-git directory
1004 nongit () {
1005         test -d non-repo ||
1006         mkdir non-repo ||
1007         return 1
1008
1009         (
1010                 GIT_CEILING_DIRECTORIES=$(pwd) &&
1011                 export GIT_CEILING_DIRECTORIES &&
1012                 cd non-repo &&
1013                 "$@"
1014         )
1015 }